'use strict';

var myapp = angular.module('myapp', []);

myapp.factory('weatherService', function($http) {
  return {
    getWeather: function() {
      var weather = { temp: {}, clouds: null };

      weather.temp.current = 27;
      weather.temp.min = 18;
      weather.temp.max = 35;
      weather.clouds = undefined;


      return weather;
    }
  };
});

myapp.filter('temp', function($filter) {
  return function(input, precision) {
    if (!precision) {
      precision = 1;
    }
    var numberFilter = $filter('number');
    return numberFilter(input, precision) + '\u00B0C';
  };
});

myapp.controller('WeatherCtrl', function ($scope, weatherService) {
  $scope.weather = weatherService.getWeather();
});

myapp.directive('weatherIcon', function() {
  return {
    restrict: 'E', replace: true,
    scope: {
      cloudiness: '@'
    },
    controller: function($scope) {
      $scope.imgurl = function() {
        var baseUrl = 'https://ssl.gstatic.com/onebox/weather/128/';
        if ($scope.cloudiness < 20) {
          return baseUrl + 'sunny.png';
        } else if ($scope.cloudiness < 90) {
          return baseUrl + 'partly_cloudy.png';
        } else {
          return baseUrl + 'cloudy.png';
        }
      };
    },
    template: '<div style="float:left"><img ng-src="{{ imgurl() }}"></div>'
  };
});
