// Karma configuration
// http://karma-runner.github.io/0.10/config/configuration-file.html

module.exports = function(config) {
  config.set({
    // base path, that will be used to resolve files and exclude
    basePath: '',

    // testing framework to use (jasmine/mocha/qunit/...)
    frameworks: ['intl-shim', 'jasmine-ajax', 'jasmine'],

    // Which plugins to enable
    plugins: [
      'karma-intl-shim',
      'karma-jasmine',
      'karma-jasmine-ajax',
      'karma-junit-reporter',
      'karma-coverage',
      'karma-ng-html2js-preprocessor',
      'karma-phantomjs-launcher'
    ],

    junitReporter: {
      outputDir: 'junitreports/', // results will be saved as $outputDir/$browserName.xml
      outputFile: undefined, // if included, results will be saved as $outputDir/$browserName/$outputFile
      suite: '', // suite will become the package name attribute in xml testsuite element
      useBrowserName: true, // add browser name to report and classes names
      nameFormatter: undefined, // function (browser, result) to customize the name attribute in xml testcase element
      classNameFormatter: undefined, // function (browser, result) to customize the classname attribute in xml testcase element
      properties: {} // key value pair of properties to add to the <properties> section of the report
    },

    coverageReporter: {
      type : 'html',
      dir : 'coverage'
    },



    // list of files / patterns to exclude
    exclude: [],

    // web server port
    port: 10001,

    // level of logging
    // possible values: LOG_DISABLE || LOG_ERROR || LOG_WARN || LOG_INFO || LOG_DEBUG
    logLevel: config.LOG_DEBUG,

    preprocessors: {
      'src/app/layout/**/*.html': ['ng-html2js'],
      'src/app/invitation/*.html':['ng-html2js'],
      'src/app/notification/notification.tpl.html':['ng-html2js'],
      'src/app/media/form/form.tpl.html':['ng-html2js'],
      'src/app/media/form/fieldset.tpl.html':['ng-html2js'],
      'src/app/media/chat/emoji/emojiPanel.tpl.html':['ng-html2js'],
      'src/app/media/wcb/wcb.tpl.html':['ng-html2js'],
      'src/app/time-picker/timePicker.tpl.html':['ng-html2js'],

      'src/app/AnchorButton/*.js': ['coverage'],
      'src/app/common/*.js': ['coverage'],
      'src/app/error/*.js': ['coverage'],
      'src/app/invitation/*.js': ['coverage'],
      'src/app/layout/**/*.js': ['coverage'],
      'src/app/media/**/*.js': ['coverage'],
      'src/app/messages/aip.tpl.js': ['coverage'],
      'src/app/messages/AIPConnector.js': ['coverage'],
      'src/app/messages/CORSConnector.js': ['coverage'],
      'src/app/messages/EventModel.js': ['coverage'],
      'src/app/messages/proxy.js': ['coverage'],
      'src/app/messages/readerSvc.js': ['coverage'],
      'src/app/navigation/*.js': ['coverage'],
      'src/app/notification/*.js': ['coverage'],
      'src/app/services/*.js': ['coverage'],
      'src/app/session/*.js': ['coverage'],
      'src/app/time-picker/*.js': ['coverage'],
      'src/app/widget/*.js': ['coverage'],
      'src/app/app.js': ['coverage']
    },

    ngHtml2JsPreprocessor: {
      stripPrefix: 'src/'
    },
    // enable / disable watching file and executing tests whenever any file changes
    autoWatch: false,


    // Start these browsers, currently available:
    // - Chrome
    // - ChromeCanary
    // - Firefox
    // - Opera
    // - Safari (only Mac)
    // - PhantomJS
    // - IE (only Windows)
    browsers: ['PhantomJS'],

    browserNoActivityTimeout: 60000,

    // Continuous Integration mode
    // if true, it capture browsers, run tests and exit
    singleRun: true,

    colors : true,

    //reporters
    reporters: ['progress','junit','coverage']

  });
};
