/**
 * Created by ythirion on 25/04/16.
 */
'use strict';

angular.module('akio.webbox')

  .factory('clickToChatButton', ['boxParams','$log','state',function(boxParams,$log,state){


    var clickToChatButton = {};
    /**
     * hide iframe and display click to chat button.
     * add a click event on click to chat button.
     *
     * @returns {Function}
     */

    clickToChatButton.displayAsButton = function(){

      //we get all buttons
      var buttonChatAvailable = jQuery(window.parent.document.querySelector(boxParams.CTC_BUTTON.BUTTON_DEFAULT));
      var buttonChatNotAvailable = jQuery(window.parent.document.querySelector(boxParams.CTC_BUTTON.BUTTON_NOT_AVAILABLE));
      var buttonChatIsChatting = jQuery(window.parent.document.querySelector(boxParams.CTC_BUTTON.BUTTON_IS_CHATTING));

      $log.info('Akio Box display as button');

      //if a button is define for chat unavailable we display it first.
      if (buttonChatNotAvailable && buttonChatNotAvailable.length!==0){
        buttonChatNotAvailable.show();
      }
      //we add a click event on the button
      buttonChatAvailable.click(
        function(){
          //we recover the diplayMedium function from the launchbar Scope
          var launchBarDisplayMedium = angular.element('.awb-launchbar-wrapper').scope().displayMedium;
          //we recover the chat medium from the launchbar scope
          var mediumChat = state.mediaList.findWhere({uuid: "2"});
          //we start conversation And show iframe after 400ms (time for the launcbar animation)
          launchBarDisplayMedium(mediumChat);

          //if a button is define for isChatting state we display it and hide the ctc default button
          if (buttonChatIsChatting.length!==0){
            buttonChatIsChatting.show();
            buttonChatAvailable.hide();
          }
        }
      );
    };


    /**
     * display the approriate button according to medium availability, akio-web-box state , and button id parameters
     * @returns {Function}
     */

    clickToChatButton.displayAppropriateButton = function(isMediaChatOpenAndAvailable,isOngoingChatSession,isNetConnectionDown){

      if (boxParams.CTC_BUTTON) {
        var buttonChatAvailable = jQuery(boxParams.CTC_BUTTON.BUTTON_DEFAULT, window.parent.document);
        var buttonChatNotAvailable = jQuery(boxParams.CTC_BUTTON.BUTTON_NOT_AVAILABLE, window.parent.document);
        var buttonChatIsChatting = jQuery(boxParams.CTC_BUTTON.BUTTON_IS_CHATTING, window.parent.document);

        //if chat is not available and button is define for chat unavailable, display the button
        if (buttonChatNotAvailable.length !== 0 && !isMediaChatOpenAndAvailable) {
          buttonChatNotAvailable.show();
          buttonChatAvailable.hide();
          buttonChatIsChatting.hide();

        }else if( isMediaChatOpenAndAvailable && isOngoingChatSession && !isNetConnectionDown){
          //if user is chatting and button is define for for isChatting state, display the button
          if (buttonChatIsChatting.length !==0 ){
            buttonChatIsChatting.show();
            buttonChatAvailable.hide();
            buttonChatNotAvailable.hide();
            //if user is chatting and button is not define for for isChatting state, display the default button
          }else{
            buttonChatIsChatting.hide();
            buttonChatAvailable.show();
            buttonChatNotAvailable.hide();
          }

          //if the medium is open/available and no conversation is initiate,
        }else if(isMediaChatOpenAndAvailable && !isOngoingChatSession && !isNetConnectionDown){
          buttonChatNotAvailable.hide();
          buttonChatAvailable.show();
          buttonChatIsChatting.hide();


        }else if(isNetConnectionDown){
          buttonChatNotAvailable.show();
          buttonChatAvailable.hide();
          buttonChatIsChatting.hide();
        }else{// else, in all other state we hide all buttons
          buttonChatNotAvailable.hide();
          buttonChatAvailable.hide();
          buttonChatIsChatting.hide();
        }
      }
    };

    return clickToChatButton;
  }]);
