/**
 * Created by ythirion on 02/11/16.
 */

'use strict';

angular.module('akio.webbox')

  .factory('clickToWcbButton', ['boxParams','state',function(boxParams,state){


    var clickToWcbButton = {};
    /**
     * hide iframe and display click to chat button.
     * add a click event on click to chat button.
     *
     * @returns {Function}
     */

    clickToWcbButton.displayAsButton = function(){

      //we get all buttons
      var buttonWcbAvailable = jQuery(window.parent.document.querySelector(boxParams.WCB_BUTTON.BUTTON_DEFAULT));
      var buttonWcbNotAvailable = jQuery(window.parent.document.querySelector(boxParams.WCB_BUTTON.BUTTON_NOT_AVAILABLE));
      var buttonWcbIsCalling = jQuery(window.parent.document.querySelector(boxParams.WCB_BUTTON.BUTTON_IS_CALLING));


      //if a button is define for chat unavailable we display it first.
      if (buttonWcbNotAvailable && buttonWcbNotAvailable.length!==0){
        buttonWcbNotAvailable.show();
      }
      //we add a click event on the button
      buttonWcbAvailable.click(
        function(){
          //we recover the diplayMedium function from the launchbar Scope
          var launchBarDisplayMedium = angular.element('.awb-launchbar-wrapper').scope().displayMedium;
          //we recover the chat medium from the launchbar scope
          var mediumWcb = state.mediaList.findWhere({uuid: "8"});
          //we start conversation And show iframe after 400ms (time for the launchbar animation)
          launchBarDisplayMedium(mediumWcb);
          //if a button is define for isChatting state we display it and hide the ctc default button
          if (buttonWcbIsCalling.length!==0){
            buttonWcbIsCalling.show();
            buttonWcbAvailable.hide();
          }
        }
      );
    };


    /**
     * display the approriate button according to medium availability, akio-web-box state , and button id parameters
     * @returns {Function}
     */

    clickToWcbButton.displayAppropriateButton = function(isMediaWcbOpenAndAvailable,isOngoingWcbSession,isNetConnectionDown){

      if (boxParams.CTC_BUTTON) {
        var buttonWcbAvailable = jQuery(boxParams.WCB_BUTTON.BUTTON_DEFAULT, window.parent.document);
        var buttonWcbNotAvailable = jQuery(boxParams.WCB_BUTTON.BUTTON_NOT_AVAILABLE, window.parent.document);
        var buttonWcbIsCalling = jQuery(boxParams.WCB_BUTTON.BUTTON_IS_CALLING, window.parent.document);

        //if chat is not available and button is define for chat unavailable, display the button
        if (buttonWcbNotAvailable.length !== 0 && !isMediaWcbOpenAndAvailable) {
          buttonWcbNotAvailable.show();
          buttonWcbAvailable.hide();
          buttonWcbIsCalling.hide();

        }else if( isMediaWcbOpenAndAvailable && !isNetConnectionDown && isOngoingWcbSession){
          //if user is chatting and button is define for for isChatting state, display the button
          if (buttonWcbIsCalling.length !==0 ){
            buttonWcbIsCalling.show();
            buttonWcbAvailable.hide();
            buttonWcbNotAvailable.hide();
            //if user is chatting and button is not define for for isChatting state, display the default button
          }else{
            buttonWcbIsCalling.hide();
            buttonWcbAvailable.show();
            buttonWcbNotAvailable.hide();
          }

          //if the medium is open/available and no conversation is initiate,
        }else if(isMediaWcbOpenAndAvailable && !isNetConnectionDown && !isOngoingWcbSession){
          buttonWcbNotAvailable.hide();
          buttonWcbAvailable.show();
          buttonWcbIsCalling.hide();


        }else if(isNetConnectionDown){
          buttonWcbNotAvailable.show();
          buttonWcbAvailable.hide();
          buttonWcbIsCalling.hide();
        }else{// else, in all other state we hide all buttons
          buttonWcbNotAvailable.hide();
          buttonWcbAvailable.hide();
          buttonWcbIsCalling.hide();
        }
      }
    };

    return clickToWcbButton;
  }]);
