'use strict';

//    <!-- build:include ../js/akioTargeting.js -->
//    This will be replaced by the content of js/akioTargeting.js
//    The code must be injected here because the targeting rules must be evaluated on the page containing the webbox
//    <!-- /build -->

(function() {


  (function() {
    var method;
    var noop = function () {};
    var methods = [
      'assert', 'clear', 'count', 'debug', 'dir', 'dirxml', 'error',
      'exception', 'group', 'groupCollapsed', 'groupEnd', 'info', 'log',
      'markTimeline', 'profile', 'profileEnd', 'table', 'time', 'timeEnd',
      'timeStamp', 'trace', 'warn'
    ];
    var length = methods.length;
    var console = (window.console = window.console || {});

    while (length--) {
      method = methods[length];

      // Only stub undefined methods.
      if (!console[method]) {
        console[method] = noop;
      }
    }
  }());

  var isDisplayedOnSmartphone = false;
  var isDisplayedOnTablet = false;

  if (navigator.userAgent.match(/Android|iPhone|Windows Phone|IEMobile|BlackBerry/i)&& parent.window.matchMedia("(max-width: 640px)").matches){
    isDisplayedOnSmartphone=true;
  }else if (navigator.userAgent.match(/Android|iPad|IEMobile/i)&& parent.window.matchMedia("(min-width: 640px)").matches){
    isDisplayedOnTablet = true;
  }


  var iFrameLoader = function () {
    // Create the iframe containing the webbox
    var webboxIFrame = document.createElement('IFRAME');
    webboxIFrame.setAttribute('frameborder', '0');
    webboxIFrame.style.position = 'relative';
    webboxIFrame.style.width = '100%';
    webboxIFrame.style.height = '100%';
    webboxIFrame.style.overflow = 'hidden';
    webboxIFrame.style.backgroundColor = 'transparent';
    webboxIFrame.id = 'akioWebBoxIFrame';
    webboxIFrame.name = '';


    // Create the webbox iframe wrapper
    var webboxIFrameWrapper = document.createElement('DIV');
    webboxIFrameWrapper.style.zIndex = '1000000';
    webboxIFrameWrapper.style.position = 'fixed';
    webboxIFrameWrapper.style.bottom = '0';
    webboxIFrameWrapper.id="akioWebBoxIFrameWrapper";
    webboxIFrameWrapper.style.height = '0px';

    if (isDisplayedOnSmartphone || isDisplayedOnTablet) {
      webboxIFrameWrapper.style.boxShadow = 'none';
      webboxIFrameWrapper.style.transition= 'box-shadow .4s ease-in-out';
    }

    // Inject the iframe and the wrapper in the page
    webboxIFrameWrapper.appendChild(webboxIFrame);
    var body = document.body;
    body.appendChild(webboxIFrameWrapper);

    var base = "";
    var webBoxLauncherScript = document.getElementById('akioWebBoxLauncherUrl');
    if(webBoxLauncherScript && webBoxLauncherScript.src) {
      var split = webBoxLauncherScript.src.split('/');
      base = split.slice(0, -2).join('/')+'/';
    }

    // Inject the html in the iframe
    var akioWebBoxIFrame = document.getElementById('akioWebBoxIFrame'),
      akioWebBoxIFrameDocument = akioWebBoxIFrame.contentDocument ? akioWebBoxIFrame.contentDocument : akioWebBoxIFrame.contentWindow.document;
    akioWebBoxIFrameDocument.open();
    akioWebBoxIFrameDocument.write('<!doctype html><html><head><meta charset="utf-8"><meta http-equiv="X-UA-Compatible" content="IE-edge"><meta name="viewport" content="width=device-width, initial-scale=1.0,minimum-scale=1.0,maximum-scale=1.0,user-scalable=no, shrink-to-fit=no, minimal-ui"><meta name="referrer" content="always"><link rel="stylesheet" href="'+base+'styles/@@project.artifactId.css" /><link rel="stylesheet" href="'+base+'styles/custom-@@project.artifactId.css" /><link rel="stylesheet" href="'+base+'styles/sourceSansPro.css" /><link rel="stylesheet" href="'+base+'styles/openSans.css" /><script>window.AkioBaseUrl="'+base+'";</script><script src="'+base+'js/@@project.artifactId-core-@@project.version.min.js"></script><script src="'+base+'js/akio_gtm.js"></script></head><body ng-app="akio.webbox"><div awb-widget id="awbWidget"></div></body></html>');
    akioWebBoxIFrameDocument.close();
  };

  // Add IFrame when the page is loaded
  if(document.readyState === 'complete'|| document.readyState === 'interactive') {
    iFrameLoader();
  } else {
    document.addEventListener('DOMContentLoaded', iFrameLoader);
  }

})();
