'use strict';

//    <!-- build:include ../js/akioTargeting.js -->
//    This will be replaced by the content of js/akioTargeting.js
//    The code must be injected here because the targeting rules must be evaluated on the page containing the webbox
//    <!-- /build -->
(function() {

  (function() {
    var method;
    var noop = function () {};
    var methods = [
      'assert', 'clear', 'count', 'debug', 'dir', 'dirxml', 'error',
      'exception', 'group', 'groupCollapsed', 'groupEnd', 'info', 'log',
      'markTimeline', 'profile', 'profileEnd', 'table', 'time', 'timeEnd',
      'timeStamp', 'trace', 'warn'
    ];
    var length = methods.length;
    var console = (window.console = window.console || {});

    while (length--) {
      method = methods[length];

      // Only stub undefined methods.
      if (!console[method]) {
        console[method] = noop;
      }
    }
  }());

  var isDisplayedOnSmartphone = false;
  var isDisplayedOnTablet = false;

  if (navigator.userAgent.match(/Android|iPhone|Windows Phone|IEMobile|BlackBerry/i)&& parent.window.matchMedia("(max-width: 640px)")){
    isDisplayedOnSmartphone=true;
  }else if (navigator.userAgent.match(/Android|iPad|IEMobile/i)&& parent.window.matchMedia("(min-width: 640px)")){
    isDisplayedOnTablet = true;
  }


  // Add IFrame when the page is loaded
  document.addEventListener('DOMContentLoaded', function () {
    // Create the iframe containing the webbox
    var webboxIFrame = document.createElement('IFRAME');
    webboxIFrame.setAttribute('frameborder', '0');
    webboxIFrame.style.position = 'relative';
    webboxIFrame.style.width = '100%';
    webboxIFrame.style.height = '100%';
    webboxIFrame.style.overflow = 'hidden';
    webboxIFrame.style.backgroundColor = 'transparent';
    webboxIFrame.id = 'akioWebBoxIFrame';
    webboxIFrame.name = '';


    // Create the webbox iframe wrapper
    var webboxIFrameWrapper = document.createElement('DIV');
    webboxIFrameWrapper.style.zIndex = '1000000';
    webboxIFrameWrapper.style.position = 'fixed';
    webboxIFrameWrapper.style.bottom = '0';
    webboxIFrameWrapper.id="akioWebBoxIFrameWrapper";
    webboxIFrameWrapper.style.height = '0px';

    if (isDisplayedOnSmartphone || isDisplayedOnTablet) {
      webboxIFrameWrapper.style.boxShadow = 'none';
      webboxIFrameWrapper.style.transition= 'box-shadow .4s ease-in-out';
    }

    // Inject the iframe and the wrapper in the page
    webboxIFrameWrapper.appendChild(webboxIFrame);
    var body = document.body;
    body.appendChild(webboxIFrameWrapper);

    var base = "";
    var webBoxLauncherScript = document.getElementById('akioWebBoxLauncherUrl');
    if(webBoxLauncherScript && webBoxLauncherScript.src) {
      var split = webBoxLauncherScript.src.split('/');
      base = split.slice(0, -2).join('/')+'/';
    }

    // Inject the html in the iframe
    var akioWebBoxIFrame = document.getElementById('akioWebBoxIFrame'),
      akioWebBoxIFrameDocument = akioWebBoxIFrame.contentDocument ? akioWebBoxIFrame.contentDocument : akioWebBoxIFrame.contentWindow.document;
    akioWebBoxIFrameDocument.open();
    akioWebBoxIFrameDocument.write('<!doctype html><html><head><meta charset="utf-8"><meta http-equiv="X-UA-Compatible" content="IE-edge"><meta name="viewport" content="width=device-width, initial-scale=1.0,minimum-scale=1.0,maximum-scale=1.0,user-scalable=no, shrink-to-fit=no, minimal-ui"><meta name="referrer" content="always"><link rel="stylesheet" href="styles/akio-webbox.css" /><link rel="stylesheet" href="styles/custom-akio-webbox.css" /><link rel="stylesheet" href="styles/openSans.css" /><link rel="stylesheet" href="styles/sourceSansPro.css" /><script>window.AkioBaseUrl="'+base+'";</script><script src="bower_components/jquery/dist/jquery.js"></script><script src="bower_components/jquery-color/jquery.color.js"></script><script src="bower_components/angular/angular.js"></script><script src="bower_components/underscore/underscore.js"></script><script src="bower_components/backbone/backbone.js"></script><script src="bower_components/angular-animate/angular-animate.js"></script><script src="bower_components/angular-resource/angular-resource.js"></script><script src="bower_components/mobile-detect/mobile-detect.js"></script><script src="bower_components/angular-sanitize/angular-sanitize.js"></script><script src="bower_components/ng-content-editable/dist/ng-content-editable.min.js"></script><script src="libs/backbone.domStorage.js"></script><script src="bower_components/lodash/dist/lodash.js"></script><script src="app/app.js"></script><script src="app/AnchorButton/clickToChatFactory.js"></script><script src="app/AnchorButton/clickToWcbFactory.js"></script><script src="app/common/languageDetection.js"></script><script src="app/common/loader.js"></script><script src="app/common/emojisConstant.js"></script><script src="app/common/animates.js"></script><script src="app/common/constants.js"></script><script src="app/common/filters.js"></script><script src="app/common/fix1404.js"></script><script src="app/common/fixIeSelect.js"></script><script src="app/common/xmlUtils.js"></script><script src="app/common/transformTextToSend.js"></script><script src="app/common/determineClient.js"></script><script src="app/invitation/triggerSvc.js"></script><script src="app/invitation/triggerDrct.js"></script><script src="app/layout/common/button.js"></script><script src="app/layout/launchbar/launchBarCtrl.js"></script><script src="app/layout/launchbar/launchBarDrct.js"></script><script src="app/layout/window/westRegionContainerDrct.js"></script><script src="app/layout/window/northRegionContainerDrct.js"></script><script src="app/layout/window/titlebarDrct.js"></script><script src="app/layout/window/windowCtrl.js"></script><script src="app/layout/window/windowDrct.js"></script><script src="app/layout/window/waitCtrl.js"></script><script src="app/layout/window/chatFormCtrl.js"></script><script src="app/layout/window/chatFormDrct.js"></script><script src="app/layout/common/imageBrokenDrct.js"></script><script src="app/media/media.js"></script><script src="app/media/MediumModel.js"></script><script src="app/media/chat/chatCtrl.js"></script><script src="app/media/chat/emoji/emojiDrct.js"></script><script src="app/media/chat/emoji/emojiCtrl.js"></script><script src="app/media/wcb/wcbDrct.js"></script><script src="app/media/wcb/wcbCtrl.js"></script><script src="app/media/wcb/calendar/wcbCalendarDrct.js"></script><script src="app/media/wcb/calendar/wcbCalendarCtrl.js"></script><script src="app/media/wcb/confirm/wcbCconfirmDrct.js"></script><script src="app/media/wcb/confirm/wcbConfirmCtrl.js"></script><script src="app/media/chat/ChatModule.js"></script><script src="app/media/form/formCtrl.js"></script><script src="app/media/form/FormModule.js"></script><script src="app/media/form/formEvent.js"></script><script src="app/media/form/surveyEvent.js"></script><script src="app/media/chat/chatInvitationEvent.js"></script><script src="app/media/form/fieldsetDrct.js"></script><script src="app/navigation/navigation.js"></script><script src="app/notification/notificationDrct.js"></script><script src="app/notification/notificationCtrl.js"></script><script src="app/notification/notificationSvc.js"></script><script src="app/messages/AIPConnector.js"></script><script src="js/proxy.js"></script><script src="app/messages/CORSConnector.js"></script><script src="app/messages/EventModel.js"></script><script src="app/messages/readerSvc.js"></script><script src="app/error/serviceUnavailableEvent.js"></script><script src="app/error/networkConnectionLazyEvent.js"></script><script src="app/error/serviceInterruptedEvent.js"></script><script src="app/error/errorHandler.js"></script><script src="app/services/messages.js"></script><script src="app/services/configuration.js"></script><script src="app/services/externalInterface.js"></script><script src="app/session/dataContext.js"></script><script src="app/session/session.js"></script><script src="app/widget/widgetDrct.js"></script><script src="app/widget/widgetCtrl.js"></script><script src="app/time-picker/timePickerDrct.js"></script><script src="app/time-picker/timePickerUtils.js"></script></head><body ng-app="akio.webbox"><div awb-widget id="awbWidget"></div></body></html>');
    akioWebBoxIFrameDocument.close();
  });

})();
