'use strict';

// globals
/**
 * exposes the application's reference name in the storage as a service
 */

angular.module('akio.webbox')

  /**
   * border layout types
   */
  .constant('Layout', {
    BORDER_CENTER: 0,
    BORDER_NORTH : 1,
    BORDER_WEST  : 2
  })

  .constant('ViewState', {
    STATE_NONE     : undefined,
    STATE_CHATBOX  : 'CHATBOX',
    STATE_FORM     : 'FORM',
    STATE_WAIT     : 'WAIT',
    STATE_WCB      :'WCB',
    STATE_WCB_CALENDAR       :'WCB-CALENDAR',
    STATE_WCB_CONFIRM       :'WCB-CONFIRM',
    STATE_CHATFORM : 'CHATFORM'
  })

  .constant('ErrorCode', {
    CRITICAL   : 0,
    RESTART    : 1,
    RESUME     : 2,
    INFORMATION: 4,
    WARNING    : 5,
    ERROR      : 2,
    KEEP_UI     : 6
  })

  .constant('MediumType', {
    MEDIUM_CHAT: 'CHAT',
    MEDIUM_WCB : 'VOICE'
  })

  .constant('MediumViewStatus', {
    MEDIUM_STATUS_PENDING: 0,
    MEDIUM_STATUS_OPENED : 1,
    MEDIUM_STATUS_CLOSED : 2,
    MEDIUM_STATUS_CLOSING: 3,
    MEDIUM_STATUS_CALENDAR: 4,
    MEDIUM_STATUS_CONFIRM: 5
  })

  .constant('MediumStatus', {
    MEDIUM_STATUS_CLOSED            : 'CLOSED',            // call center is closed
    MEDIUM_STATUS_OPEN_AVAILABLE    : 'OPEN_AVAILABLE',    // call center is opened and some agents are available
    MEDIUM_STATUS_OPEN_NOT_AVAILABLE: 'OPEN_NOT_AVAILABLE', // call center is opened but no agents are currently available
    MEDIUM_STATUS_DELAYED_WEBCALLBACK: 'OPEN_DELAYED_WEBCALLBACK' // call center is opened and delayed webcallback is available
    //MEDIA_STATUS_NOT_AVAILABLE: 'NOT_AVAILABLE'
  })

  .constant('OpenMediaResultEventStatus', {
    OK                : 'OK',                 // the medium has opened successfully
    DISSUADED         : 'DISSUADED',          // the agent has dismissed your request
    ALERTING          : 'ALERTING',
    WAITING           : 'WAITING',            // demande mise en file d'attente
    POOL_CUSTOMER_FULL: 'POOL_CUSTOMER_FULL', // no more room in the queue
    BAD_SERVICE       : 'BAD_SERVICE',        // bad queue
    NO_AGENT          : 'NO_AGENT',           // no more agent available on the plateform
    OVERFLOW          : 'OVERFLOW',           // dépassement de la capacité au niveau de la distribution
    AGENT_ABORT       : 'AGENT_ABORT'
  })

  .constant('WcbdStatus',{
    CALL_TIME_SLOT_CREATED : 'CALL_TIME_SLOT_CREATED',
    CALL_TIME_SLOT_ALREADY_EXISTS : 'CALL_TIME_SLOT_ALREADY_EXISTS',
    INTERNAL_SERVER_ERROR : 'INTERNAL_SERVER_ERROR'
  });
