'use strict';

angular.module('akio.webbox')

  .factory('determineClient', function(){

    var md;
    /* jshint ignore:start */
    md = new MobileDetect(window.navigator.userAgent);
    /* jshint ignore:end */

    /**
     *
     * @returns {*|number|DOMLocator|Location|String}
     */
    function determineUrl(){
      return document.location;
    }

    /**
     *
     * @returns {string}
     */
    function determineDevice(){
      if (md.phone()!==null){
        return 'smartphone';
      }else if (md.tablet()!==null){
        return 'tablet';
      }else {
        return 'desktop';
      }
    }

    function determineOS(){
      return md.os()||'unknown';
    }

    function determineViewport(){
      var viewport = {};
      viewport.height = parent.window.screen.availHeight;
      viewport.width = parent.window.screen.availWidth;

      return viewport;
    }


    return {
      url     : determineUrl(),
      device  : determineDevice(),
      os      : determineOS(),
      viewport: determineViewport()
    };
  });
