'use strict';

/**
 * the ERROR handler
 */

angular.module( 'akio.webbox' )

  .factory( 'errorHandler', [ '$resource', 'ErrorCode', '$injector', 'trigger', 'Event',
    function( $resource, ErrorCode, $injector, trigger, Event ) {

      var interpret = function ( errCode ){
        var e;
        switch ( errCode ){
          case ErrorCode.CRITICAL:
            // the error is critical. The Box is unusable and so hidden
            $injector.get('session').quit( );
            break;

          case ErrorCode.RESUME:
            // we offer the user the possibility to catchup the active session
            e = new Event( new $injector.get( 'networkConnectionLazyEvent' ) );
            trigger.register( e, -1 /* not be restored */ );
            break;

          case ErrorCode.RESTART:
            e = new Event( new $injector.get( 'serviceInterruptedEvent' ) );
            // we offer the user the possibility to create a new session
            trigger.register( e, -1 /* not be restored */ );
            break;

          case ErrorCode.KEEP_UI:
            //do nothing
            break;



          //case ErrorCode.ERROR:
          //case ErrorCode.INFORMATION:
          //case ErrorCode.WARNING:
          //  break;
        }
      };

      return {
        interpret: interpret
      };
    }
  ]);
