'use strict';

angular.module('akio.webbox')
  .directive('awbButton', function(){
    var link = function(scope, element, attrs){
      if (attrs.toggle === 'true'){
        element.addClass('awb-button-toggle');
        element.on('click', function(event){
          // toggle selected state
          event.preventDefault();
          element.toggleClass('awb-button-selected');
        });
      }else{
        element.addClass('awb-button-no-toggle');
      }
    };

    return {
      transclude: true,
      restrict: 'EA',
      scope: {
        toggle: '@'
      },
      link: link,
      replace: true,
      template: '<a href="" class="awb-button" ng-transclude></a>'
    };
  })

  .directive('awbButtonState', function(){
    return {
      transclude: true,
      restrict: 'EA',
      replace: true,
      template: '<div class="awb-button-state" ng-transclude></div>'
    };
  });
