'use strict';

var form = angular.module('form', []);

/**
 * generic form directive
 */
form.directive('awbGenericForm', function(){

  function link (scope, iElement){

    // adjust sub-elements position & size
    var element = jQuery(iElement),
      footerHeight = element.find('.awb-form-footer').outerHeight(),
      parentHeight = element.parent().height();
    element.width(element.parent().width())
      .find('.awb-form-body')
      .outerHeight(parentHeight-footerHeight-6);

    // adjust buttons width
    element.find('button').parent().innerWidth( element.find('.awb-form-footer').width() * 0.5 );

    /**
     * hold form values
     */
    scope.formData = {};

    /**
     * Submit form
     */
    scope.doSubmit = function(){
      scope.submit({formData:scope.formData});
    };

    /**
     * tells whether the form can't be save
     */
    scope.canSave = function(){
      return scope.userProfileForm.$dirty &&
        scope.userProfileForm.$valid;
    };

    scope.showError = function(ngModelController, error) {
      return ngModelController.$error[error];
    };
  }

  return {
    restrict: "EA",
    replace: true,
    scope: {
      items : "=",
      title : "@",
      submit: "&",
      cancel: "&"
    },
    templateUrl: "app/media/form/form.tpl.html",
    link: link
  };
});
