'use strict';

/**
 * list of media available on the platform
 *
 * @dictionary http://svn.akio.fr/svn/repos/com/akio/aip/trunk/akio-aip-rest-api/src/main/resources/dictionary/media.xsd
 */
angular.module('akio.webbox')
  .factory('media', ['i18nMessages', 'boxParams', 'MediumType',
    function( labels, boxParams, MediumType ){

      var i = 0;

      var service = {
        getMediaExtrasDescription: function( mediumTypeSeek ){

          var medium = _.find( boxParams.RULES.MEDIA_PRIORITY_LIST, function( item ){
              return item.type === mediumTypeSeek;
            }),
            result;

          // no priority rules are set. they all have the same priority. We can presume that there is only one medium offered
          if ( _.isUndefined( medium ) ){
            medium = {
              priority: 1,
              renderer:"BUTTON"
            };
          }

          switch ( mediumTypeSeek ){
            case MediumType.MEDIUM_CHAT:
              result =  {
                title      : labels.MEDIUM_CHAT_TITLE+(i++),
                message    : labels.LAUNCHBOX_TITLE_CHAT, /* REQUIRED */
                description: 'no description',
                textInput  : true,
                exposed    : true,
                icon       : 'icon-chat'
              };
              break;


            case MediumType.MEDIUM_WCB:
              result = {
                title      : labels.MEDIUM_WCB_TITLE,
                message    : labels.LAUNCHBOX_TITLE_WCB,
                description: 'no description',
                textInput  : false,
                exposed    : true,
                icon       : 'icon-phone'
              };
          }

          return _.assign(result, {priority: medium.priority, renderer: medium.renderer});
        }
      };

      return service;
    }
  ]);
