'use strict';
angular.module('akio.webbox')

  .controller('wcbCalendarCtrl', ['$scope', '$log', 'i18nMessages', 'aip', 'state', 'boxParams', 'session', 'MediumViewStatus', 'WcbdStatus',
    function ($scope, $log, labels, aip, state, boxParams, session, MediumViewStatus, WcbdStatus) {

      var mediumUuid = state.getCenterRegion().mediumUuid;

      $scope.displayCalendar = false;

      $scope.selectedDate = null;

      // define labels for UI
      $scope.explanation = labels.WCB_CALENDAR_EXPLANATION;
      $scope.confirmButton = labels.WCB_CALENDAR_CONFIRM_BUTTON;

      $scope.disableConfirmButton = true;

      $scope.onUpdateSelection = function (value) {
        $scope.selectedDate = value;
      };

      aip.getWebcallbackCalendar(Date.now())
        .then(function (response) {
          var jsonResponse = JSON.parse(response);
          if (jsonResponse.hasOwnProperty('timeSlots')) {
            $scope.timeslots = jsonResponse.timeSlots;
            $scope.displayCalendar = true;
          }
        });

      $scope.openMediaWcb = function() {
        var phoneNumberToSend = state.getPhoneNumber();
        var alphaCode = state.getSelectedCountry().alphaCode;
        var callbackTime = $scope.selectedDate.fromDate;
        var callbackTimeEnd = $scope.selectedDate.toDate;

        //check if it's a SIP number
        var regexSip = /^(sip:)/;
        if (boxParams.ALLOW_SIP_NUMBER && regexSip.test(phoneNumberToSend)) {
          alphaCode = null;
        }

        aip.openMediaWcbd(alphaCode, phoneNumberToSend, callbackTime, callbackTimeEnd)
          .then(function () {
            session.stopPolling();
            state.setMediaStatus(mediumUuid, MediumViewStatus.MEDIUM_STATUS_CONFIRM);
            state.setWcbdStatus(WcbdStatus.CALL_TIME_SLOT_CREATED);
            state.setWcbDate($scope.selectedDate);
          },
          function (result) {
            console.log(JSON.stringify(result.data.status));
            if(result.data.status === 409){
              state.setWcbdStatus(WcbdStatus.CALL_TIME_SLOT_ALREADY_EXISTS);
            } else {
              state.setWcbdStatus(WcbdStatus.INTERNAL_SERVER_ERROR);
            }
            state.setWcbDate(null);
            state.setMediaStatus(mediumUuid, MediumViewStatus.MEDIUM_STATUS_CONFIRM);
            session.fetchMediaIsRunning = true;
          });

      };

    }
  ]);
