'use strict';
angular.module('akio.webbox')

  .controller('wcbConfirmCtrl', ['$scope', 'state', 'i18nMessages', 'boxParams', 'WcbdStatus',
    function ($scope, state, labels, boxParams, WcbdStatus) {

      $scope.formatDate = function (date) {
        return date.toLocaleDateString(languageDetection(boxParams.I18N), {
          weekday: 'long',
          year: 'numeric',
          month: 'long',
          day: 'numeric',
          hour: 'numeric',
          minute: 'numeric'
        });
      };

      // define labels for UI
      if(state.getWcbdStatus() === WcbdStatus.CALL_TIME_SLOT_CREATED){
        $scope.explanation = labels.WCB_CONFIRM_REQUEST_OK_EXPLANATION;
        $scope.message = labels.WCB_CONFIRM_REQUEST_OK_MESSAGE + '<br />' + $scope.formatDate(new Date(state.getWcbDate().fromDate));
      } else if (state.getWcbdStatus() === WcbdStatus.CALL_TIME_SLOT_ALREADY_EXISTS) {
        $scope.explanation = labels.WCB_CONFIRM_REQUEST_ALREADY_EXISTS_EXPLANATION;
        $scope.message = labels.WCB_CONFIRM_REQUEST_ALREADY_EXISTS_MESSAGE;
      } else {
        $scope.explanation = labels.WCB_CONFIRM_REQUEST_KO_EXPLANATION;
        $scope.message = labels.WCB_CONFIRM_REQUEST_KO_MESSAGE;
      }

    }
  ]);
