'use strict';

/**
 * The ExternalInterface class is an application programming interface that enables straightforward communication between Javascript and the angular application container.
 * responsability:
 * - navigate to a medium
 */
angular.module('akio.webbox')
  .factory('externalInterface', ['navigation', 'state', 'formEvent', 'chatInvitationEvent', 'surveyEvent', 'networkConnectionLazyEvent', 'messageReader',
    function( navigation, state, formEvent, chatInvitationEvent, surveyEvent, networkConnectionLazyEvent, messageReader ){
      
      return {
        navigateTo: function( mediumType ){
          var medium =  state.mediaList.findWhere( {type: mediumType });
          try {
            navigation.goto( medium );
          }catch(err){
            // medium name is invalid
            var cause   = 'externalInterface.navigateTo';
            err.message += ' (caused by "' + cause + '")';
            throw err.message;
          }
        },

        // DEBUG: testing trigger from the html page

        sendFormEvent: function(){
          messageReader.injectEvent( formEvent );
        },

        sendChatInvitation: function(){
          messageReader.injectEvent( chatInvitationEvent );
        },

        sendSurveyInvitation: function(){
          messageReader.injectEvent( surveyEvent );
        },

        sendErrorInvitation: function(){
          messageReader.injectEvent( networkConnectionLazyEvent );
        }
      };

    }
  ]);
