'use strict';

angular.module('akio.webbox')

  .controller('timePickerCtrl', ['$scope', 'timePickerUtils',
    function ($scope, timePickerUtils) {
      function hasTimeSlotsOnPreviousDay() {
        var maxDatePreviousDay = timePickerUtils.cloneDate($scope.currentDate);
        maxDatePreviousDay.setDate($scope.currentDate.getDate() - 1);
        maxDatePreviousDay.setHours(23, 59, 59, 999);
        return $scope.minDate <= maxDatePreviousDay;
      }

      function hasTimeSlotsOnNextDay() {
        var minDateNextDay = timePickerUtils.cloneDate($scope.currentDate);
        minDateNextDay.setDate($scope.currentDate.getDate() + 1);
        minDateNextDay.setHours(0, 0, 0, 0);
        return $scope.maxDate >= minDateNextDay;
      }

      function update() {
        $scope.currentDateDisplay = timePickerUtils.formatDate($scope.currentDate);
        $scope.hours = timePickerUtils.getHours(sortedTimeslots[$scope.currentDate.getTime()] || []);
        $scope.hasTimeSlotsOnPreviousDay = hasTimeSlotsOnPreviousDay();
        $scope.hasTimeSlotsOnNextDay = hasTimeSlotsOnNextDay();
      }

      var sortedTimeslots = timePickerUtils.sortTimeslotsByDay($scope.timeslots);

      $scope.currentDate = timePickerUtils.getFirstDisplayedDate($scope.timeslots);
      $scope.minDate = timePickerUtils.getMinDate($scope.timeslots);
      $scope.maxDate = timePickerUtils.getMaxDate($scope.timeslots);
      update();

      $scope.selectedTimestamp = $scope.currentDate.getTime();

      $scope.swipeRight = false;

      $scope.selectDate = function (value) {
        $scope.selectedDate = value.fromDate;
        $scope.updateSelection({value: value});
      };

      $scope.nextDay = function () {
        $scope.currentDate.setDate($scope.currentDate.getDate() + 1);
        $scope.swipeRight = false;
        update();
      };

      $scope.previousDay = function () {
        $scope.currentDate.setDate($scope.currentDate.getDate() - 1);
        $scope.swipeRight = true;
        update();
      };

    }
  ]);
