'use strict';

describe('test click to chat factory',function(){
  beforeEach(module('akio.webbox'));
  var clickToChatButton, buttonChatNotAvailable, ctcButtonIsChatting,ctcButton;
  beforeEach(inject(function(_clickToChatButton_){
    clickToChatButton = _clickToChatButton_;

    //add ctcNotAvailable to dom
    buttonChatNotAvailable = window.parent.document.createElement('DIV');
    buttonChatNotAvailable.id = 'ctcButtonNotAvailable';
    var body = window.parent.document.body;
    body.appendChild(buttonChatNotAvailable);

    //add ctcButtonIsChatting to dom
    ctcButtonIsChatting = window.parent.document.createElement('DIV');
    ctcButtonIsChatting.id = 'ctcButtonIsChatting';
    body.appendChild(ctcButtonIsChatting);

    //add ctcButtonAvailable to dom
    ctcButton = window.parent.document.createElement('DIV');
    ctcButton.id = 'ctcButton';
    body.appendChild(ctcButton);

  }));

  it('should be defined ', function() {
    expect(clickToChatButton).toBeDefined();
  });


  it('should display the appropriate ctcButtonNotAvailable button',function(){

    clickToChatButton.displayAppropriateButton(false,false,true);


    expect(window.parent.document.getElementById('ctcButton').style.display).toEqual('none');
    expect(window.parent.document.getElementById('ctcButtonIsChatting').style.display).toEqual('none');
    expect(window.parent.document.getElementById('ctcButtonNotAvailable').style.display).toEqual('');


  });

  it('should display the appropriate ctcButtonIsChatting button',function(){

    clickToChatButton.displayAppropriateButton(true,true,false);

    expect(window.parent.document.getElementById('ctcButton').style.display).toEqual('none');
    expect(window.parent.document.getElementById('ctcButtonIsChatting').style.display).toEqual('block');
    expect(window.parent.document.getElementById('ctcButtonNotAvailable').style.display).toEqual('none');

  });

  it('should display the appropriate ctcButton button',function(){

    clickToChatButton.displayAppropriateButton(true,false,false);

    expect(window.parent.document.getElementById('ctcButton').style.display).toEqual('block');
    expect(window.parent.document.getElementById('ctcButtonIsChatting').style.display).toEqual('none');
    expect(window.parent.document.getElementById('ctcButtonNotAvailable').style.display).toEqual('none');
  });

  it('should display the appropriate ctcButtonNotAvailable button',function(){

    clickToChatButton.displayAppropriateButton(true,false,true);

    expect(window.parent.document.getElementById('ctcButton').style.display).toEqual('none');
    expect(window.parent.document.getElementById('ctcButtonIsChatting').style.display).toEqual('none');
    expect(window.parent.document.getElementById('ctcButtonNotAvailable').style.display).toEqual('block');
  });

  it('should display the appropriate ctcButtonNotAvailable button',function(){

    clickToChatButton.displayAppropriateButton(false,true,false);

    expect(window.parent.document.getElementById('ctcButton').style.display).toEqual('none');
    expect(window.parent.document.getElementById('ctcButtonIsChatting').style.display).toEqual('none');
    expect(window.parent.document.getElementById('ctcButtonNotAvailable').style.display).toEqual('block');
  });

  it('should display as button',function(){

    clickToChatButton.displayAsButton();
    expect(clickToChatButton.displayAsButton).toBeDefined();
  });

  /*it('should start a chat when user is clicking',function(){

    clickToChatButton.displayAsButton();
    clickToChatButton.displayAppropriateButton(true,false,false);
    console.log(window.parent.document);
    ctcButton.click();
    expect(clickToChatButton.displayAsButton).Not.toBeDefined();
  });*/
});
