'use strict';

describe('test click to wcb factory',function(){
  beforeEach(module('akio.webbox'));
  var clickToWcbButton, buttonWcbNotAvailable, wcbButtonIsCalling, wcbButton;
  beforeEach(inject(function(_clickToWcbButton_){
    clickToWcbButton = _clickToWcbButton_;

    //add ctcNotAvailable to dom
    buttonWcbNotAvailable = window.parent.document.createElement('DIV');
    buttonWcbNotAvailable.id = 'wcbButtonNotAvailable';
    var body = window.parent.document.body;
    body.appendChild(buttonWcbNotAvailable);

    //add ctcButtonIsChatting to dom
    wcbButtonIsCalling = window.parent.document.createElement('DIV');
    wcbButtonIsCalling.id = 'wcbButtonIsCalling';
    body.appendChild(wcbButtonIsCalling);

    //add ctcButtonAvailable to dom
    wcbButton = window.parent.document.createElement('DIV');
    wcbButton.id = 'wcbButton';
    body.appendChild(wcbButton);

  }));


  it('should be defined ', function() {
    expect(clickToWcbButton).toBeDefined();
  });


  it('should display the appropriate button',function(){

    clickToWcbButton.displayAppropriateButton(false,false,true);
    expect(window.parent.document.getElementById('wcbButton').style.display).toEqual('none');
    expect(window.parent.document.getElementById('wcbButtonIsCalling').style.display).toEqual('none');
    expect(window.parent.document.getElementById('wcbButtonNotAvailable').style.display).toEqual('');
  });



  it('should display the appropriate button',function(){

    clickToWcbButton.displayAppropriateButton(true,true,false);
    expect(window.parent.document.getElementById('wcbButton').style.display).toEqual('none');
    expect(window.parent.document.getElementById('wcbButtonIsCalling').style.display).toEqual('block');
    expect(window.parent.document.getElementById('wcbButtonNotAvailable').style.display).toEqual('none');
  });



  it('should display the appropriate button',function(){

    clickToWcbButton.displayAppropriateButton(true,false,false);
    expect(window.parent.document.getElementById('wcbButton').style.display).toEqual('block');
    expect(window.parent.document.getElementById('wcbButtonIsCalling').style.display).toEqual('none');
    expect(window.parent.document.getElementById('wcbButtonNotAvailable').style.display).toEqual('none');
  });

  it('should display the appropriate button',function(){

    clickToWcbButton.displayAppropriateButton(true,false,true);
    expect(window.parent.document.getElementById('wcbButton').style.display).toEqual('none');
    expect(window.parent.document.getElementById('wcbButtonIsCalling').style.display).toEqual('none');
    expect(window.parent.document.getElementById('wcbButtonNotAvailable').style.display).toEqual('block');
  });


  it('should display as button',function(){
    clickToWcbButton.displayAsButton();
    expect(clickToWcbButton.displayAsButton).toBeDefined();
  });
});
