'use strict';

//for animation test example, see : https://www.sitepoint.com/angularjs-testing-tips-bootstrap-blocks-routes-events-animations/


describe('test animate',function(){
  beforeEach(module('akio.webbox.animates'));
  var animate,rootScope, rootElement,divElement;

  beforeEach(function () {
    module('ngAnimate', 'ngAnimateMock');
    inject(function ($animate, $rootScope, $rootElement) {
      $animate.enabled(true);
      animate = $animate;
      rootScope = $rootScope;
      rootElement = $rootElement;
      divElement = angular.element('<div class="awb-fade-animation">This is my view</div>');
      rootScope.$digest();
    });
  });


  it('should enter awb-fade-animation', function (done) {

    animate.enter(divElement, rootElement);
    rootScope.$digest();
    setTimeout(function () {
      console.log(divElement);
      expect(divElement.css('display')).toEqual('');
      done();
    },500);

  });

  it('should leave awb-fade-animation', function (done) {
    rootElement.append(divElement);

    animate.leave(divElement, rootElement);
    rootScope.$digest();
    setTimeout(function () {
      expect(divElement.css('display')).toEqual('');
      done();
    },500);

  });


});

