'use strict';

describe('test determineClient function',function(){

  beforeEach(module('akio.webbox'));

  beforeEach(function() {
    if(!window.Akio) { window.Akio={}; }
    if(!window.Akio.Webbox) { window.Akio.Webbox={}; }
    if(!window.Akio.Webbox.settings) { window.Akio.Webbox.settings={}; }
    if(!window.Akio.Webbox.settings.parameters) { window.Akio.Webbox.settings.parameters={}; }
    if(!window.Akio.Webbox.settings.parameters.I18N) { window.Akio.Webbox.settings.parameters.I18N='"fr"'; }
    if(!window.Akio.Webbox.settings.parameters.IS_DISPLAY_AS_BUTTON) { window.Akio.Webbox.settings.parameters.IS_DISPLAY_AS_BUTTON='false'; }
  });

  afterEach(function() {
    sessionStorage.clear();
  });

  var determineClient;
  beforeEach(inject(function(_determineClient_){
    determineClient = _determineClient_;
  }));

  it('should return an object', function() {
    expect(determineClient).toEqual((jasmine.any(Object)));
  });

  it('should determine that the device is a desktop', function() {
    var device = determineClient.device;
    expect(device).toEqual('desktop');
  });

  it('should determine that the device is not a tablet', function() {
    var device = determineClient.device;
    expect(device).not.toEqual('smartphone');
  });

  it('should determine that the device is not a smartPhone', function() {
    var device = determineClient.device;
    expect(device).not.toEqual('tablet');
  });

  it('should detect an url', function(){
    var url = determineClient.url;
    expect(url.href).toMatch(/^(https?:\/\/)?((\d{1,3}\.){3}\d{1,3}|[\w\.-]*)(:\d{1,5})?(\/[^\s]*)?$/i);
    //expect(url.href).toMatch(/(((https?:\/\/)|(w{2}))[\w-]+((\.|\:)[\w-]+)+\.?(:\d+)?(\/\S*)?)/gi);
  });

  // it('should detect the language',function(){
  //   var language = determineClient.language;
  //   expect(language).toMatch(new RegExp('fr'));
  // });

});
