/* global languageDetection */

'use strict';

describe('test languageDetection function',function(){

  beforeEach(function() {
    if(!window.Akio) { window.Akio={}; }
    if(!window.Akio.Webbox) { window.Akio.Webbox={}; }
    if(!window.Akio.Webbox.settings) { window.Akio.Webbox.settings={}; }
    if(!window.Akio.Webbox.settings.parameters) { window.Akio.Webbox.settings.parameters={}; }
    if(!window.Akio.Webbox.settings.parameters.I18N) { window.Akio.Webbox.settings.parameters.I18N='"fr"'; }
  });

  afterEach(function() {
    sessionStorage.clear();
  });

  it ('should detect the language of the web browser',function(){
    var language = languageDetection(window.Akio.Webbox.settings.parameters.I18N);
    expect(language).toMatch(new RegExp('fr'));
  });

  it ('should detect the language of the web browser',function(){
    var language = languageDetection('webBrowser');
    expect(language).toEqual(navigator.language);
  });

});
