'use strict';

describe('test transformText factory',function(){
  beforeEach(module('akio.webbox'));

  var transformTextFactory;
  beforeEach(inject(function(_transformText_){
    transformTextFactory = _transformText_;
  }));

  afterEach(function() {
    sessionStorage.clear();
  });

  it('should be defined ', function() {
    expect(transformTextFactory).toBeDefined();
  });

  it('should not change a text with no span',function(){
    var message = transformTextFactory.deleteSpanAndAddEmoticonCharacter('salut');
    expect(message).toEqual('salut');
  });

  it('should change a text with a span',function(){
    var text = '<span class="emoji emoji-yum" id="1512568009471" contenteditable="false" name="1F60B" unselectable="on"></span>&nbsp';
    var message = transformTextFactory.deleteSpanAndAddEmoticonCharacter(text);
    expect(message).not.toEqual(text);
  });

});
