'use strict';

describe('test xmlUtils factory',function(){
  beforeEach(module('akio.webbox'));

  var xmlUtilsFactory;
  beforeEach(inject(function(_xmlUtils_){
    xmlUtilsFactory = _xmlUtils_;
  }));

  afterEach(function() {
    sessionStorage.clear();
  });

  it('should be defined ', function() {
    expect(xmlUtilsFactory).toBeDefined();
  });

  it('should add node',function(){
    var message = xmlUtilsFactory.surroundAndXMLParse('salut');
    expect(message).toEqual(jasmine.any(Object));
  });

  it('should extract the text',function(){
    var message = xmlUtilsFactory.surroundAndXMLParse('salut');
    expect(xmlUtilsFactory.xmlSerializeAndUnSurround(message)).toEqual('salut');
  });

  it('should not extract the text',function(){
    window.DOMParser=undefined;
    var message = xmlUtilsFactory.surroundAndXMLParse('salut');
    expect(xmlUtilsFactory.xmlSerializeAndUnSurround(message)).not.toEqual('salut');
  });




});
