'use strict';

describe('test errorHandler factory',function(){

  beforeEach(module('akio.webbox'));

  var errorHandlerFactory, ErrorCode,state,serviceInterruptedEvent;

  beforeEach(inject(function(_errorHandler_,_ErrorCode_,_state_,_serviceInterruptedEvent_){
    errorHandlerFactory = _errorHandler_;
    ErrorCode=_ErrorCode_;
    state = _state_;
    serviceInterruptedEvent  = _serviceInterruptedEvent_;
  }));

  afterEach(function () {
    errorHandlerFactory = null;
    state = null;
    ErrorCode = null;
    serviceInterruptedEvent=null;
    window.sessionStorage.clear();
  });

  it('should be defined ', function() {
    expect(errorHandlerFactory).toBeDefined();
  });

  it('should interpret error code ', function() {
    state.sync({});

    errorHandlerFactory.interpret(ErrorCode.CRITICAL);
    errorHandlerFactory.interpret(ErrorCode.RESUME);
    errorHandlerFactory.interpret(ErrorCode.RESTART);

    expect(errorHandlerFactory.interpret).toBeDefined();
  });

});
