'use strict';

describe('test trigger factory',function() {

  beforeEach(module('akio.webbox'));

  var trigger,Event,$injector,state,$rootScope;

  beforeEach(inject(function (_trigger_,_Event_,_$injector_,_state_,_$rootScope_) {
    trigger = _trigger_;
    Event=_Event_;
    $injector=_$injector_;
    state=_state_;
    $rootScope=_$rootScope_;
    state.sync({});

  }));

  it('should be defined ', function () {
    expect(trigger).toBeDefined();
  });

  it('should say if trigger exist or not ', function () {
    var currentTriggerExist = trigger.exists();
    expect(currentTriggerExist).toEqual(false);
  });

  it('should register an event', function () {

    var e = new Event( new $injector.get( 'networkConnectionLazyEvent' ) );
    var myEvent =trigger.register(e,-1);
    var currentTriggerExist = trigger.exists();
    expect(currentTriggerExist).toEqual(true);


    var expectedResult = {
      eventType:'NetworkConnectionLazyEvent',
      eventId:undefined,
      eventData:undefined
    };
    expect(myEvent.description()).toEqual(expectedResult);


  });
  it('should unregister an event', function () {

    var e = new Event( new $injector.get( 'networkConnectionLazyEvent' ) );
    var myEvent =trigger.register(e,-1);



    //todo: find a better way to test this
    myEvent.reject();
    myEvent.accept();
    expect(state.events().length).toEqual(0);

  });

});
