'use strict';

describe('directive: chatForm', function() {
  var element,compile, $scope, state, boxParams;

  beforeEach(module('akio.webbox'));
  beforeEach(module('app/layout/window/chatForm.tpl.html'));



  beforeEach(inject(function($rootScope, $compile,_state_, _boxParams_) {
    $scope = $rootScope.$new();
    compile = $compile;
    state=_state_;
    boxParams=_boxParams_;
    state.sync({});
    state.mediaList.set([{'conditionUuid':'497a9c9f-1e1d-47f7-bed6-333ffd440f72','uuid':'2','name':'Chat','status':'OPEN_AVAILABLE','estimatedWaitTime':25,'type':'CHAT'},{'conditionUuid':'dedd5031-075a-451b-9e93-dfec6e2d1eff','uuid':'8','name':'WebCallback','status':'OPEN_AVAILABLE','estimatedWaitTime':25,'type':'VOICE'}]);

    var data ={
      'parameters': {
        'TOKEN_AUTHENTICATION'        : '1bba5583-d068-496d-a9d8-a5bb2139c97c',
        'AIP_SERVICE_BASE_URL'        : 'http://uicdev/akio-cim-aip/api/v1',
        'XDOMAIN_IFRAME_URL'          : 'http://uicdev/iframe.html',
        'XDOMAIN_IFRAME_ORIGIN'       : '*',
        'SERVER_URL'                  : '',
        'HTTP_RETRY_ON_FAILURE_COUNT' : 2,
        'HTTP_RETRY_ON_FAILURE_DELAY' : 2000,

        'RULES':{
          'BOX_DELAY_BEFORE_DISPLAY': 0,
          'BOX_HIDDEN_WHEN_NO_MEDIA': true
        },
        'I18N'  : 'webBrowser',
        'COMMUNICATION_ERROR_MESSAGE': 'error'
      }
    };

    element = compile(angular.element('<awb-chat-form></awb-chat-form>'))($scope);

    $scope.state = state;

    $scope.state.data=_.merge(boxParams, data.parameters);

    $scope.$digest();

  }));

  it('should create an html element', function(){
    $scope.$apply();
    console.log(element.html());
    expect(element.html()).not.toEqual('');
  });

});
