'use strict';

describe('directive: north region', function() {
  var element,compile, $scope, state, boxParams;

  beforeEach(module('akio.webbox'));
  beforeEach(module('app/layout/window/northRegionContainer.tpl.html'));



  beforeEach(inject(function($rootScope, $compile,_state_, _boxParams_) {
    $scope = $rootScope.$new();
    compile = $compile;
    state=_state_;
    boxParams=_boxParams_;
    state.sync({});

    var data ={
      'parameters': {
        'TOKEN_AUTHENTICATION'        : '1bba5583-d068-496d-a9d8-a5bb2139c97c',
        'AIP_SERVICE_BASE_URL'        : 'http://uicdev/aip/api/v1',
        'XDOMAIN_IFRAME_URL'          : 'http://uicdev/iframe.html',
        'XDOMAIN_IFRAME_ORIGIN'       : '*',
        'SERVER_URL'                  : '',
        'HTTP_RETRY_ON_FAILURE_COUNT' : 2,
        'HTTP_RETRY_ON_FAILURE_DELAY' : 2000,

        'RULES':{
          'BOX_DELAY_BEFORE_DISPLAY': 0,
          'BOX_HIDDEN_WHEN_NO_MEDIA': true
        },
        'I18N'  : 'webBrowser',
        'COMMUNICATION_ERROR_MESSAGE': 'error'
      }
    };

    _.merge(boxParams, data.parameters);

    element = compile(angular.element('<div awb-north-region-container></div>'))($scope);

    $scope.$digest();

  }));

  afterEach(function() {
    sessionStorage.clear();
  });

  it('should instantiate scope.isChat to false', function(){
    expect(element.scope().isChat).toEqual(false);
  });



  it('should create an html element', function(){
    element.scope().isChat = true;
    $scope.$apply();
    expect(element.html()).not.toEqual('');
  });

});
