'use strict';

describe('directive: titleBar', function() {
  var element,compile, $scope, state,session, boxParams,labels,Layout;

  beforeEach(module('akio.webbox'));
  beforeEach(module('app/layout/window/titlebar.tpl.html'));



  beforeEach(inject(function($rootScope, $compile,_state_,_session_, _boxParams_,i18nMessages, _Layout_) {
    $scope = $rootScope.$new();
    compile = $compile;
    state=_state_;
    boxParams=_boxParams_;
    labels = i18nMessages;
    Layout = _Layout_;
    session = _session_;
    state.sync({});

    var data ={
      'parameters': {
        'TOKEN_AUTHENTICATION'        : '1bba5583-d068-496d-a9d8-a5bb2139c97c',
        'AIP_SERVICE_BASE_URL'        : 'http://uicdev/akio-cim-aip/api/v1',
        'XDOMAIN_IFRAME_URL'          : 'http://uicdev/iframe.html',
        'XDOMAIN_IFRAME_ORIGIN'       : '*',
        'SERVER_URL'                  : '',
        'HTTP_RETRY_ON_FAILURE_COUNT' : 2,
        'HTTP_RETRY_ON_FAILURE_DELAY' : 2000,

        'RULES':{
          'BOX_DELAY_BEFORE_DISPLAY': 0,
          'BOX_HIDDEN_WHEN_NO_MEDIA': true
        },
        'I18N'  : 'webBrowser',
        'COMMUNICATION_ERROR_MESSAGE': 'error'
      }
    };

    element = compile(angular.element('<awb-titlebar></awb-titlebar>'))($scope);
    $scope.state = state.sync({});
    $scope.state.data=_.merge(boxParams, data.parameters);
    $scope.state.data.get=function(ui){
      var fakeUi= ui;
      console.log(fakeUi);
      return {
        defaults: {
          collapse: false, // chatBoxState: tells whether the box is collapsed or expanded. Two values: OPEN | CLOSE
          zoom: 1 /* zoom coefficient. */
        }
      };
    };
    $scope.state.data.save=function(object){
      var fakeUi= object;
      console.log(fakeUi);
      return fakeUi;
    };


    $scope.$digest();

  }));

  it('should create an html element', function(){
    $scope.$apply();
    expect(element.html()).not.toEqual('');
  });

  it('should have a setPanelAsClosable function', function(){
    $scope.titleBar.setPanelAsClosable(true) ;
    $scope.$apply();
    expect($scope.titleBar.setPanelAsClosable).toBeDefined();
  });

  it('should have a expand function', function(){
    $scope.titleBar.expand() ;
    $scope.$apply();
    expect($scope.titleBar.expand).toBeDefined();
  });

  it('should have a logout function', function(){
    $scope.logout() ;
    $scope.$apply();
    expect($scope.logout).toBeDefined();
  });

  it('should have a logout function', function(){
    session.fetchMediaIsRunning=true;
    $scope.logout() ;
    $scope.$apply();
    expect($scope.logout).toBeDefined();
  });

  it('should have a toggleCollapse function', function(){
    var event={};
    event.stopPropagation = function(){return 'fakeFunction';};
    $scope.titleBar.toggleCollapse(event) ;
    $scope.$apply();
    expect($scope.titleBar.toggleCollapse).toBeDefined();
  });

  it('should have a close function', function(){
    var event={};
    event.preventDefault = function(){return 'fakeFunction';};
    $scope.titleBar.close(event) ;
    $scope.$apply();
    expect($scope.titleBar.close).toBeDefined();
  });

  it('should have a close function', function(){
    var event={};
    event.preventDefault = function(){return 'fakeFunction';};
    var title = $scope.expandButtonLabel() ;
    $scope.$apply();
    expect(title).toEqual(labels.BOX_BUTTON_EXPAND);
  });


  it('should have a close function', function(){
    state.setRegion({constraint:Layout.BORDER_CENTER});
    var event={};
    event.preventDefault = function(){return 'fakeFunction';};
    var title = $scope.expandButtonLabel() ;
    $scope.$apply();
    expect(title).toEqual(labels.BOX_BUTTON_EXPAND);
  });

});
