'use strict';

describe('test windowCtrl controller', function() {


  beforeEach(module('akio.webbox'));

  beforeEach(function() {
    if(!window.Akio) { window.Akio={}; }
    if(!window.Akio.Webbox) { window.Akio.Webbox={}; }
    if(!window.Akio.Webbox.settings) { window.Akio.Webbox.settings={}; }
    if(!window.Akio.Webbox.settings.parameters) { window.Akio.Webbox.settings.parameters={}; }
    if(!window.Akio.Webbox.settings.parameters.I18N) { window.Akio.Webbox.settings.parameters.I18N='"fr"'; }
  });

  var $controller, state, windowController, $scope, $rootScope, $element;

  beforeEach(inject(function(_$controller_, _state_, _$rootScope_){
    $controller = _$controller_;
    state = _state_;
    $rootScope = _$rootScope_;
    $element = angular.element('<div></div>');
    $element.height = function() {
      return 50;
    };

    //instantiate a new state
    state.sync({});

    //set a media result
    var mediaResult = {
      description : 'no description',
      estimatedWaitTime : 9,
      exposed :  true,
      icon : 'fa-comments-o',
      message : 'Ask us by Chat !',
      name : 'Chat',
      priority : 1,
      renderer : 'BUTTON',
      status : 'OPEN_AVAILABLE',
      textInput : true,
      title : 'Chat295',
      type : 'CHAT',
      uuid :'2'
    };

    //set the media in the state
    state.mediaList.set(mediaResult);
    $scope = {};

    windowController = $controller('windowCtrl', { $scope: $scope, $rootScope: $rootScope, $element: $element });

  }));

  it('defined a controller',function(){
    expect(windowController).toBeDefined();
  });

  it('should return a viewState',function(){
    state.getByRegion=function(fakeConstraint){
      return{
        constraint:fakeConstraint,
        mediumStatus:1,
        mediumType:'CHAT',
        mediumUuid:'2'

      };
    };

    expect($scope.win.getViewState(0)).toEqual('CHATBOX');

    state.getByRegion=function(fakeConstraint){
      return{
        constraint:fakeConstraint,
        mediumStatus:1,
        mediumType:'NLS',
        mediumUuid:'2'

      };
    };

    expect($scope.win.getViewState(0)).toEqual('SEARCH');

    state.getByRegion=function(fakeConstraint){
      return{
        constraint:fakeConstraint,
        mediumStatus:1,
        mediumType:'VOICE',
        mediumUuid:'8'

      };
    };
    state.mediaList.set([{'conditionUuid':'497a9c9f-1e1d-47f7-bed6-333ffd440f72','uuid':'2','name':'Chat','status':'OPEN_AVAILABLE','estimatedWaitTime':25,'type':'CHAT'},{'conditionUuid':'dedd5031-075a-451b-9e93-dfec6e2d1eff','uuid':'8','name':'WebCallback','status':'OPEN_AVAILABLE','estimatedWaitTime':25,'type':'VOICE'}]);

    expect($scope.win.getViewState(0)).toEqual('WCB');

  });

  it('defined if it has a north region',function(){
    $scope.titleBar = 'title';
    state.getCenterRegion=function(){return{mediumType:'CHAT'};};

    expect($scope.win.hasRegionNorth()).toEqual(false);

  });

  it('defined if it has a west region',function(){
    $scope.titleBar = 'title';
    expect($scope.win.hasRegionWest()).toEqual(false);

  });

  it('defined if it has a west region',function(){
    expect($scope.win.hasTrigger()).toEqual(false);

  });

  it('should tells if conversation is over',function(){
    expect($scope.win.isConversationOver()).toEqual(true);

  });

  it('should tells if navigation is locked',function(){
    expect($scope.win.isNavigationLocked()).toEqual(false);

  });
});
