'use strict';

describe('test MediaCollection factory',function(){

  beforeEach(module('akio.webbox'));

  var MediaCollection;
  var Backbone;
  var MediumModel;

  beforeEach(inject(function(_MediaCollection_,_Backbone_,_MediumModel_){
    MediaCollection = _MediaCollection_;
    Backbone=_Backbone_;
    MediumModel=_MediumModel_;
  }));

  afterEach(function() {
    sessionStorage.clear();
  });

  it('should be defined', function() {
    expect(MediaCollection).toBeDefined();
  });

  it('should create a new media collection', function() {
    var myMediaCollection = new MediaCollection();

    expect(myMediaCollection).toBeDefined();
  });

  it('should tell if multiple media are available', function() {
    var myMediaCollection = new MediaCollection();

    expect(myMediaCollection.hasMultipleNlMediaAvailable()).toBe(false);
  });

  it('should tell there is no media are available', function() {
    var myMediaCollection = new MediaCollection();

    expect(myMediaCollection.hasSomeAvailable()).toBe(false);
  });

  it('should tell there is a media available for chat', function() {
    var myMediaCollection = new MediaCollection();
    var mediaResult = {
      conditionUuid:'dedd5031-075a-451b-9e93-dfec6e2d1eff',
      uuid:'2',
      name:'Chat',
      status:'OPEN_AVAILABLE',
      estimatedWaitTime:25,
      type:'CHAT'
    };
    myMediaCollection.set(mediaResult);

    expect(myMediaCollection.hasSomeAvailable()).toBe(true);
  });

  it('should tell there is a media available for instant webcallback', function() {
    var myMediaCollection = new MediaCollection();
    var mediaResult = {
      conditionUuid:'dedd5031-075a-451b-9e93-dfec6e2d1eff',
      uuid:'8',
      name:'Voice',
      status:'OPEN_AVAILABLE',
      estimatedWaitTime:25,
      type:'VOICE'
    };
    myMediaCollection.set(mediaResult);

    expect(myMediaCollection.hasSomeAvailable()).toBe(true);
  });

  it('should tell there is a media available for delayed webcallback', function() {
    var myMediaCollection = new MediaCollection();
    var mediaResult = {
      conditionUuid:'dedd5031-075a-451b-9e93-dfec6e2d1eff',
      uuid:'8',
      name:'Voice',
      status:'OPEN_DELAYED_WEBCALLBACK',
      estimatedWaitTime:25,
      type:'VOICE'
    };
    myMediaCollection.set(mediaResult);

    expect(myMediaCollection.hasSomeAvailable()).toBe(true);
  });
});
