'use strict';

describe('test MediumModel factory',function(){

  beforeEach(module('akio.webbox'));

  var MediumModel, MediumStatus;

  beforeEach(inject(function(_MediumModel_,_MediumStatus_){
    MediumModel = _MediumModel_;
    MediumStatus = _MediumStatus_;
  }));

  afterEach(function() {
    sessionStorage.clear();
  });

  it('should be defined ', function() {
    expect(MediumModel).toBeDefined();
  });

  it('should create a new medium ', function() {
    var myMedium = new MediumModel();
    expect(myMedium).toBeDefined();
  });

  it('should tell if medium is open and agent available ', function() {
    var myMedium = new MediumModel();
    expect(myMedium.isOpenedAndAgentAvailable()).toBe(false);
  });

  it('should tell if medium is closed ', function() {
    var myMedium = new MediumModel();
    expect(myMedium.isClosed()).toBe(true);
  });

  it('should return a class ', function() {
    var myMedium = new MediumModel();
    expect(myMedium.getClassByStatus()).toEqual('medium-closed');
  });

  it('should return a class medium-open-available for OPEN_AVAILABLE', function() {
    var myMedium = new MediumModel();
    myMedium.set('status',MediumStatus.MEDIUM_STATUS_OPEN_AVAILABLE);
    expect(myMedium.getClassByStatus()).toEqual('medium-open-available');
  });

  it('should return a class medium-open-available for OPEN_DELAYED_WEBCALLBACK', function() {
    var myMedium = new MediumModel();
    myMedium.set('status',MediumStatus.MEDIUM_STATUS_DELAYED_WEBCALLBACK);
    expect(myMedium.getClassByStatus()).toEqual('medium-open-available');
  });

  it('should return a class medium-open-not-available', function() {
    var myMedium = new MediumModel();
    myMedium.set('status',MediumStatus.MEDIUM_STATUS_OPEN_NOT_AVAILABLE);
    expect(myMedium.getClassByStatus()).toEqual('medium-open-not-available');
  });

  it('should tell if medium has text entry ', function() {
    var myMedium = new MediumModel();
    expect(myMedium.hasTextEntry()).toBe(false);
  });
});


describe('test MediaCollection factory',function(){

  beforeEach(module('akio.webbox'));

  var MediumModel, MediumStatus, MediaCollection;

  beforeEach(inject(function(_MediumModel_,_MediumStatus_,_MediaCollection_){
    MediumModel = _MediumModel_;
    MediumStatus = _MediumStatus_;
    MediaCollection = _MediaCollection_;
  }));

  afterEach(function() {
    sessionStorage.clear();
  });


  it('should be create a new media collection ', function() {
    var mediaCollection = new MediaCollection();
    expect(mediaCollection).toBeDefined();
  });

  it('should be create a new media collection ', function() {
    var mediaCollection = new MediaCollection();
    mediaCollection.add(new MediumModel());
    //expect(mediaCollection.isPriorityMediumNl()).toEqual(false);
  });

});
