'use strict';

describe('test chat controller', function() {

  beforeEach(module('akio.webbox'));
  beforeEach(module('app/layout/window/titlebar.tpl.html'));


  var chatCtrl, $scope, state,ViewState,compile,element;

  beforeEach( inject( function($controller,$rootScope, $log, aip, $q,$compile, MediumViewStatus, notification, MediumType, i18nMessages,_state_,_ViewState_) {
    $scope = $rootScope.$new();
    ViewState = _ViewState_;
    state= _state_;
    compile=$compile;

    //instantiate a new state
    state.sync({});

    //set a media result
    var mediaResult = {
      description : 'no description',
      estimatedWaitTime : 9,
      exposed :  true,
      icon : 'fa-comments-o',
      message : 'Ask us by Chat !',
      name : 'Chat',
      priority : 1,
      renderer : 'BUTTON',
      status : 'OPEN_AVAILABLE',
      textInput : true,
      title : 'Chat295',
      type : 'CHAT',
      uuid :'2'
    };

    //set the media in the state
    state.mediaList.set(mediaResult);

    //force ViewState for make injectMessage works
    ViewState.STATE_NONE = '2';

    //awbTitlebar needed for a scope function
    element = compile(angular.element('<div awb-titlebar></div>'))($scope);

    //set the scope.state
    $scope.state = state;
    $scope.$apply();

    chatCtrl = $controller('chatCtrl',{$scope:$scope, $log:$log, state:state, aip:aip, $q:$q, MediumViewStatus:MediumViewStatus, notification:notification, MediumType:MediumType, labels:i18nMessages});

  }));

  it('should be defined', function() {
    expect(chatCtrl).toBeDefined();
  });

  it('should get the collection of events',function(){
    expect($scope.chat.events).toBeDefined();
  });

  it('should set the default text ',function(){
    expect($scope.chat.text).toEqual('');
  });

  it('should says if a media is available', function(){
    expect($scope.chat.isMediumAvailable()).toEqual(false);
  });

  it('should tells whether a conversation is ongoing', function(){
    expect($scope.chat.ongoing()).toEqual(false);
  });

  it('should tells if box have to display Restart Button', function(){
    expect($scope.chat.displayRestartButton()).toEqual(true);
  });

  it('should tells if box have to display Restart Button', function(){
    $scope.labels={CHATBOX_DOWNLOAD_CONVERSATION : 'download'};
    expect($scope.chat.logoutButtons()).toEqual(jasmine.any(Object));
  });

  it('should send aip request for downloadHistory', function(){
    $scope.chat.downloadHistory(); //todo: adda a spy
    expect($scope.chat.downloadHistory).toBeDefined();
  });

  it('should restart a conversation', function(){
    state.data.save({
      targetingRules : {
        targetingConditionUuid: [{conditionUuid:'',calendarUuid:''}] ,
        display : true
      }
    });
    $scope.chat.restart(); //todo: adda a spy
    expect($scope.chat.restart).toBeDefined();
  });

  it('should logout', function(){
    $scope.chat.logout(); //todo: adda a spy
    expect($scope.chat.logout).toBeDefined();
  });

  it('should sendMessage', function(){
    $scope.chat.sendMessage(); //todo: adda a spy
    $scope.chat.sendMessage('coucou'); //todo: adda a spy
    expect($scope.chat.sendMessage).toBeDefined();
  });



});
