'use strict';

describe('test form controller', function() {


  beforeEach(module('akio.webbox'));

  beforeEach(function() {
    if(!window.Akio) { window.Akio={}; }
    if(!window.Akio.Webbox) { window.Akio.Webbox={}; }
    if(!window.Akio.Webbox.settings) { window.Akio.Webbox.settings={}; }
    if(!window.Akio.Webbox.settings.parameters) { window.Akio.Webbox.settings.parameters={}; }
    if(!window.Akio.Webbox.settings.parameters.I18N) { window.Akio.Webbox.settings.parameters.I18N='"fr"'; }
  });

  var $controller,state,formPanelController,$scope,Event,navigation;


  beforeEach(inject(function(_$controller_, _state_,_Event_,_navigation_){
    $controller = _$controller_;
    state = _state_;
    Event=_Event_;
    navigation=_navigation_;


    //instantiate a new state
    state.sync({});

    //set a media result
    var mediaResult = {
      description : 'no description',
      estimatedWaitTime : 9,
      exposed :  true,
      icon : 'fa-comments-o',
      message : 'Ask us by Chat !',
      name : 'Chat',
      priority : 1,
      renderer : 'BUTTON',
      status : 'OPEN_AVAILABLE',
      textInput : true,
      title : 'Chat295',
      type : 'CHAT',
      uuid :'2'
    };

    //set the media in the state
    state.mediaList.set(mediaResult);
    state.data.save('regions', [{
      mediumType:'CHAT',
      constraint:0,
      mediumStatus:1,
      mediumUuid:'2',
      data:'0'
    }]);
    var e = new Event();
    e.type = 'FormRequestEvent';
    e.eventId =0 ;
    e.message = 'I am a fake event message';
    e.formData= {'type': 'VOICE'};
    state.events().add(e);
    $scope = {};

    formPanelController = $controller('formPanelCtrl', { $scope: $scope });

    spyOn(navigation, 'quit').and.callThrough();


  }));

  afterEach(function () {
    state = null;
    window.sessionStorage.clear();

  });
  it('defined a form panel controller',function(){


    expect(formPanelController).toBeDefined();

  });

  it('called quit function when submit',function(){

    $scope.submit();
    expect(navigation.quit).toHaveBeenCalled();

  });

  it('called quit function when cancel',function(){

    $scope.cancel();
    expect(navigation.quit).toHaveBeenCalled();

  });

});
