'use strict';

describe('test media factory',function(){

  beforeEach(module('akio.webbox'));

  var mediaFactory;
  var labels;
  var boxParams;
  var MediumType;

  beforeEach(inject(function(_media_,_i18nMessages_, _boxParams_, _MediumType_){
    mediaFactory = _media_;
    labels = _i18nMessages_;
    boxParams=_boxParams_;
    MediumType=_MediumType_;
  }));

  it('should be defined ', function() {
    expect(mediaFactory).toBeDefined();
  });

  it('should return an object',function(){
      var mediumDescription = mediaFactory.getMediaExtrasDescription('CHAT');
      expect(mediumDescription).toEqual(jasmine.any(Object));
    }
  );

  it('should return an extra description medium for CHAT',function(){
      var mediumDescription = mediaFactory.getMediaExtrasDescription('CHAT');
      expect(mediumDescription.textInput).toEqual(true);
      expect(mediumDescription.exposed).toEqual(true);
      expect(mediumDescription.description).toEqual('no description');
      expect(mediumDescription.icon).toEqual('icon-chat');
    }
  );

  it('should return an extra description medium for WCB',function(){
      var mediumDescription = mediaFactory.getMediaExtrasDescription('VOICE');
      expect(mediumDescription.textInput).toEqual(false);
      expect(mediumDescription.exposed).toEqual(true);
      expect(mediumDescription.description).toEqual('no description');
      expect(mediumDescription.icon).toEqual('icon-phone');
    }
  );

});
