'use strict';

/**
 * Testing AIPConnector
 * Since tests are only run against PhantomJS, the connector will always be CORSConnector
 */
describe('Test AIPConnector',function() {

  /**
   * Testing closeMediaChat
   */
  describe('closeMediaChat', function () {

    beforeEach(module('akio.webbox'));

    var AIPConnector, $rootScope, state, session;
    beforeEach(inject(function (_aip_, _$rootScope_, _state_, _session_) {
      AIPConnector = _aip_;
      $rootScope = _$rootScope_;
      state = _state_;
      session = _session_;
    }));

    beforeEach(function () {
      jasmine.Ajax.install();
    });

    afterEach(function () {
      jasmine.Ajax.uninstall();
      AIPConnector = null;
      $rootScope = null;
      state = null;
      session = null;
      window.sessionStorage.clear();

    });


    it('should stop the fetch event and start the fetch media', function () {

      //make a new state
      state.sync({});

      // Start chat session
      AIPConnector.closeMediaChat();

      jasmine.Ajax.requests.mostRecent().respondWith({
        'status': 204,
        'content': 'application/json'
      });

      // Force ajax response to be processed in AIPConnector
      $rootScope.$apply();

      expect(session.fetchMediaIsRunning).toBe(true);
      expect(session.fetchEventsIsRunning).toBe(false);

    });
  });
});
