/**
 * Created by ythirion on 25/05/16.
 */

'use strict';

/**
 * Testing AIPConnector
 * Since tests are only run against PhantomJS, the connector will always be CORSConnector
 */
describe('Test AIPConnector',function() {

  /**
   * Testing downloadHistory
   */
  describe('downloadHistory', function () {

    beforeEach(module('akio.webbox'));

    var AIPConnector, $rootScope, state, session, labels;
    beforeEach(inject(function (_aip_, _$rootScope_, _state_, _session_, i18nMessages) {
      AIPConnector = _aip_;
      $rootScope = _$rootScope_;
      state = _state_;
      session = _session_;
      labels = i18nMessages;
    }));

    beforeEach(function () {
      jasmine.Ajax.install();
    });

    afterEach(function () {
      jasmine.Ajax.uninstall();
      AIPConnector = null;
      $rootScope = null;
      state = null;
      session = null;
      labels= null;
      window.sessionStorage.clear();

    });


    it('should alert the web user that the history is no more available', function () {

      //make a new state
      state.sync({});
      spyOn(window, 'alert');

      // Start chat session
      AIPConnector.downloadHistory();

      jasmine.Ajax.requests.mostRecent().respondWith({
        'status': 204
      });

      // Force ajax response to be processed in AIPConnector
      $rootScope.$apply();


      expect(window.alert).toHaveBeenCalledWith(labels.HISTORY_NOT_AVAILABLE);

    });

    it('should alert the web user that the history is no more available', function () {

      //make a new state
      state.sync({});
      spyOn(window, 'alert');

      // Start chat session
      AIPConnector.downloadHistory();

      jasmine.Ajax.requests.mostRecent().respondWith({
        'status': 200
      });

      // Force ajax response to be processed in AIPConnector
      $rootScope.$apply();
      expect(window.alert).not.toHaveBeenCalled();

    });

  });
});
