'use strict';

/**
 * Testing AIPConnector
 * Since tests are only run against PhantomJS, the connector will always be CORSConnector
 */
describe('Test AIPConnector',function() {

  /**
   * Testing sendInputMessage
   */
  describe('sendInputMessage', function () {

    beforeEach(module('akio.webbox'));

    var AIPConnector, $rootScope, state;
    beforeEach(inject(function (_aip_, _$rootScope_, _state_) {
      AIPConnector = _aip_;
      $rootScope = _$rootScope_;
      state = _state_;
    }));

    beforeEach(function () {
      jasmine.Ajax.install();
    });

    afterEach(function () {
      jasmine.Ajax.uninstall();
      sessionStorage.clear();
    });

    it('should send a request', function () {

      //make a new state
      state.sync({});

      AIPConnector.sendInputEvent();

      jasmine.Ajax.requests.mostRecent().respondWith({
        'status': 204,
        'content': 'application/json',
        'responseText' : 'test OK'
      });

      // Force ajax response to be processed in AIPConnector
      $rootScope.$apply();

      expect(jasmine.Ajax.requests.mostRecent().responseText).toEqual('test OK');

    });

    it('should recept an error ', function () {

      //make a new state
      state.sync({});

      AIPConnector.sendInputEvent();

      jasmine.Ajax.requests.mostRecent().respondWith({
        'status': 503

      });

      // Force ajax response to be processed in AIPConnector
      $rootScope.$apply();

      expect(jasmine.Ajax.requests.mostRecent().status).toEqual(503);

    });
  });
});

