'use strict';

describe('test message reader factory',function(){

  beforeEach(module('akio.webbox'));

  var Event,state, $rootScope;


  beforeEach(inject(function( _state_, _$rootScope_,_Event_){
    $rootScope = _$rootScope_;
    state = _state_;
    Event = _Event_;
  }));


  it('should define a factory', function(){
    expect(Event).not.toBe(undefined);

  });

  it('should a new event who can call lots of method', function(){
    var myEvent= new Event();
    myEvent.get = function(){return {type:'FormSubmitEvent'};};
    myEvent.formData = {type:'undefined'};
    var result = myEvent.isMessage();
    expect(result).toEqual(false);

    var resultLog = myEvent.isLogMessage();
    expect(resultLog).toEqual(false);

    var resultAssType = myEvent.isAssistantType();
    expect(resultAssType).toEqual(false);

    var resultOpeType = myEvent.isOperatorType();
    expect(resultOpeType).toEqual(false);

    var resultSysType = myEvent.isSystemType();
    expect(resultSysType).toEqual(false);

    var resultSurv = myEvent.isSurvey();
    expect(resultSurv).toEqual(false);

    var resultUsType = myEvent.isUserType();
    expect(resultUsType).toEqual(false);

    var resultForm = myEvent.isFormSent();
    expect(resultForm).toEqual(true);

    var resultInact = myEvent.isInactivityEvent();
    expect(resultInact).toEqual(false);

    var resultChatInv = myEvent.isChatInvitation();
    expect(resultChatInv).toEqual(false);

    var resultNetConLaz = myEvent.isNetConnectionLazy();
    expect(resultNetConLaz).toEqual(false);

    var resultServiceUnavailable = myEvent.isServiceUnavailable();
    expect(resultServiceUnavailable).toEqual(false);

    var resultInvAccepted = myEvent.isInvitationAccepted();
    expect(resultInvAccepted).toEqual(false);

    var resultInvRejected = myEvent.isInvitationRejected();
    expect(resultInvRejected).toEqual(false);

    var resultTypingStarted = myEvent.isTypingStartedEvent();
    expect(resultTypingStarted).toEqual(false);

    var resultTypingStopped = myEvent.isTypingStoppedEvent();
    expect(resultTypingStopped).toEqual(false);

    var resultRequalification = myEvent.isConversationRequalificationEvent();
    expect(resultRequalification).toEqual(false);


    var resultDissuaded = myEvent.isDissuadedEvent();
    expect(resultDissuaded).toEqual(false);

    var resultDissuadedMessage = myEvent.isDissuadedMessage();
    expect(resultDissuadedMessage).toEqual(false);

    var resultOpenMediumResult = myEvent.isOpenMediumResultEvent();
    expect(resultOpenMediumResult).toEqual(false);


  });

});
