'use strict';

describe('test navigation factory',function(){
  beforeEach(module('akio.webbox'));
  var navigation,state,Event;
  beforeEach(inject(function(_navigation_,_state_,_Event_){
    navigation = _navigation_;
    state=_state_;
    Event=_Event_;
  }));
  it('should be defined ', function() {
    expect(navigation).toBeDefined();
  });


  it('should set description as undefined',function(){

    expect(navigation.description).not.toBeDefined();
  });

  it('should set a start function',function(){
    state.sync({});

    navigation.start();
    expect(navigation.start).toBeDefined();
    //expect(navigation.start).toHaveBeenCalled();
  });

  it('should set a search function',function(){

    navigation.search();
    expect(navigation.search).toBeDefined();
  });

  it('should set isLocked function',function(){
    state.sync({});
    var result = navigation.isLocked();
    expect(result).toBeDefined();
    expect(result).toEqual(false);
  });


  it('should interpret an event',function(){
    state.sync({});
    var e = new Event();
    navigation.interpretEvent(e);
    expect(navigation.interpretEvent).toBeDefined();
  });

  it('should set region by an event',function(){
    state.sync({});
    var e = new Event();
    e.get = function(){return {type:'FormSubmitEvent'};};
    navigation.setRegionByEvent(e,0);
    expect(navigation.setRegionByEvent).toBeDefined();
  });


  it('should set a leaveMedia function',function(){
    state.sync({});//todo : add a spy
    navigation.leaveMedia(2,2);
    navigation.leaveMedia(2,3);
    navigation.leaveMedia();
    expect(navigation.leaveMedia).toBeDefined();
  });

  it('should define a goto function',function(){
    state.sync({}); //todo : add a spy
    var myMedium = {attributes:{
      type:'CHAT',
      constraint:0,
      mediumStatus:1,
      uuid:'2'
    }

    };
    navigation.goto(myMedium);
    expect(navigation.goto).toBeDefined();
  });


});
