'use strict';

describe('directive: notification', function() {
  var element,$compile, $scope, state, boxParams;

  beforeEach(module('akio.webbox'));
  beforeEach(module('app/notification/notification.tpl.html'));


  beforeEach(function(){
    inject(function($rootScope, _$compile_,_state_, _boxParams_) {
      $scope = $rootScope.$new();
      $compile = _$compile_;
      state=_state_;
      boxParams=_boxParams_;
    });

    element = $compile(angular.element('<div awb-notificationbar></div>'))($scope);


  });


  it('should create an html element', function(){
    expect(element).toBeDefined();
  });

  it('should return the clickable class', function(){
    expect(element).toBeDefined();
    $scope.$digest();
    console.log($scope);
    var notification = {
      isClickable:function(){return true;},
      isCancellable:function(){return false;},
      isError:function(){return false;}
    };
    expect($scope.getCls(notification)).toEqual(['awb-notif-clickable']);
  });

  it('should return the clickable class', function(){
    expect(element).toBeDefined();
    $scope.$digest();
    console.log($scope);
    var notification = {
      isClickable:function(){return true;},
      isCancellable:function(){return false;},
      isError:function(){return false;}
    };
    expect($scope.getCls(notification)).toEqual(['awb-notif-clickable']);
  });

  it('should return the cancellable class', function(){
    expect(element).toBeDefined();
    $scope.$digest();
    console.log($scope);
    var notification = {
      isClickable:function(){return true;},
      isCancellable:function(){return true;},
      isError:function(){return false;}
    };
    expect($scope.getCls(notification)).toEqual(['awb-notif-clickable','awb-notif-cancellable']);
  });

  it('should return the error class', function(){
    expect(element).toBeDefined();
    $scope.$digest();
    console.log($scope);
    var notification = {
      isClickable:function(){return false;},
      isCancellable:function(){return false;},
      isError:function(){return true;}
    };
    expect($scope.getCls(notification)).toEqual(['awb-notif-error']);
  });


});
