'use strict';

describe('test determineClient function',function(){

  beforeEach(module('akio.webbox'));


  var notificationSvc;
  beforeEach(inject(function(_notification_){
    notificationSvc = _notification_;
  }));

  it('should return an object', function() {
    expect(notificationSvc).toEqual((jasmine.any(Object)));
  });

  it('should define a add function', function() {
    var item = {
      states:[{text:'fake'}]
    };
    var fakeCallBack=function(){return 'callback Function';};
    var delay = 3;
    var cancelable = true;
    notificationSvc.add(item,fakeCallBack,delay,cancelable);
    console.log(notificationSvc.list);
    console.log(notificationSvc.error());
    expect(notificationSvc.add).toBeDefined();
    expect(item.states[1].text).toEqual(item.states[0].text);
    expect(notificationSvc.list).toEqual((jasmine.any(Object)));
    for (var notification in notificationSvc.list){
      expect(notification).toEqual((jasmine.any(String)));
    }
  });

  it('should add a notification', function() {
    var item = {
      states:[{text:'fake'}]
    };
    var fakeCallBack=function(){return 'callback Function';};
    var delay = 3;
    var cancelable = true;
    notificationSvc.add(item,fakeCallBack,delay,cancelable);

    expect(item.states[1].text).toEqual(item.states[0].text);
    expect(notificationSvc.list).toEqual((jasmine.any(Object)));
  });

  it('should use a timestamp to name the notification description', function() {
    var item = {
      states:[{text:'fake'}]
    };
    var fakeCallBack=function(){return 'callback Function';};
    var delay = 3;
    var cancelable = true;
    notificationSvc.add(item,fakeCallBack,delay,cancelable);
    for (var notification in notificationSvc.list){

      expect(notification).toEqual((jasmine.any(String)));

    }
  });

  it('should add function to the description', function() {
    var item = {
      states:[{text:'fake'}]
    };
    var fakeCallBack=function(){return 'callback Function';};
    var delay = 3;
    var cancelable = true;
    notificationSvc.add(item,fakeCallBack,delay,cancelable);
    for (var notification in notificationSvc.list){

      expect(notificationSvc.list[notification].isClickable()).toEqual(true);
      expect(notificationSvc.list[notification].isError()).toEqual(false);
      expect(notificationSvc.list[notification].isCancellable()).toEqual(true);

      notificationSvc.list[notification].click();

    }
  });


});
