'use strict';

describe('boxParams', function() {
  var  $scope, state, boxParams;

  beforeEach(module('akio.webbox'));

  beforeEach(inject(function($rootScope, $compile,_state_, _boxParams_) {
    $scope = $rootScope.$new();
    state=_state_;
    boxParams=_boxParams_;
    state.sync({});



  }));

  it('should take the default value, if data is not defined', function(){

    var data ={
      'parameters': {
        'TOKEN_AUTHENTICATION'        : '1bba5583-d068-496d-a9d8-a5bb2139c97c',
        'I18N'  : 'webBrowser',
        'COMMUNICATION_ERROR_MESSAGE': 'error'
      }
    };

    _.merge(boxParams, data.parameters);

    $scope.$digest();

    expect(boxParams.POLLING_DELAY_LOW).toEqual(60000);
    expect(boxParams.POLLING_DELAY_EVENT).toEqual(2000);
    expect(boxParams.POLLING_DELAY_MEDIA).toEqual(5000);

  });

  it('should take the data value, if data is defined', function(){

    var data ={
      'parameters': {
        'TOKEN_AUTHENTICATION'        : '1bba5583-d068-496d-a9d8-a5bb2139c97c',
        'I18N'  : 'webBrowser',
        'COMMUNICATION_ERROR_MESSAGE': 'error',
        'POLLING_DELAY_LOW': 10000,
        'POLLING_DELAY_EVENT':3000,
        'POLLING_DELAY_MEDIA':6000
      }
    };

    _.merge(boxParams, data.parameters);

    $scope.$digest();

    expect(boxParams.POLLING_DELAY_LOW).not.toEqual(60000);
    expect(boxParams.POLLING_DELAY_LOW).toEqual(10000);
    expect(boxParams.POLLING_DELAY_EVENT).toEqual(3000);
    expect(boxParams.POLLING_DELAY_EVENT).not.toEqual(2000);
    expect(boxParams.POLLING_DELAY_MEDIA).toEqual(6000);
    expect(boxParams.POLLING_DELAY_MEDIA).not.toEqual(5000);


  });


});
