'use strict';

describe('test configuration factory',function(){

  beforeEach(module('akio.webbox'));

  var configuration, $rootScope;


  beforeEach(inject(function(_configuration_, _$rootScope_){
    configuration = _configuration_;
    $rootScope = _$rootScope_;
    jasmine.Ajax.install();

  }));

  afterEach(function() {
    sessionStorage.clear();
    $rootScope = null;
    window.sessionStorage.clear();
    jasmine.Ajax.uninstall();
  });


  it('should be defined', function() {

    var conf ={
      messages:{
        BOX_BUTTON_CONTRACT:'masquer la zone de conversation'
      },
      parameters:{
        AIP_SERVICE_BASE_URL:'http://uicdev.akio.fr/akio-cim-aip/api/v1'
      }
    };

    configuration.read(conf);
    $rootScope.$apply();
    expect(configuration).not.toBe(undefined);///todo : make an expect more precise
    //console.log(configuration);
    //expect(configuration.validate).not.toBe(undefined);
  });
  it('should detect a bad AIP_SERVICE_BASE_URL', function() {

    var conf ={
      messages:{
        BOX_BUTTON_CONTRACT:'masquer la zone de conversation'
      },
      parameters:{
        AIP_SERVICE_BASE_URL:'uicdev.akio.fr/akio-cim-aip/api/v1',
        CHAT_FORM :
        [
          {
            'type':'title',
            'textKey' : 'CHAT_FORM_TITLE'
          },
          {
            'type':'button',
            'textKey' : 'CHAT_FORM_VALID_BUTTON'
          }
        ]
      }
    };

    configuration.read(conf);
    $rootScope.$apply();
    expect(configuration).not.toBe(undefined);
  });


  it('should detect a bad AIP_SERVICE_BASE_URL', function() {

    var conf ={
      messages:{
        BOX_BUTTON_CONTRACT:'masquer la zone de conversation',
        BOX_CONTACT_EMAIL:'contact@akio.com'
      },
      parameters:{
        AIP_SERVICE_BASE_URL:'uicdev.akio.fr/akio-cim-aip/api/v1',
        CHAT_FORM :
        [
          {
            'type':'title',
            'textKey' : 'CHAT_FORM_TITLE'
          }

        ],
        BOX_CONTACT_EMAIL:true
      }
    };

    configuration.read(conf);
    $rootScope.$apply();
    expect(configuration).not.toBe(undefined);
  });

  it('should be ok', function() {

    var conf ={
      messages:{
        BOX_BUTTON_CONTRACT:'masquer la zone de conversation',
        BOX_CONTACT_EMAIL:'contact@akio.com'
      },
      parameters:{

        'TOKEN_AUTHENTICATION'        : '7a59e7f9-65ba-4ec3-8897-2310008161fc',

        'AIP_SERVICE_BASE_URL'        : 'https://uicdev.akio.fr/akio-cim-aip/api/v1',

        'SERVER_URL'                  : '@@serverUrl',

        'HTTP_RETRY_ON_FAILURE_DELAY' : 2000,
        'POLLING_DELAY_EVENT'         : 2000,
        'POLLING_DELAY_MEDIA'         : 5000,
        'POLLING_DELAY_LOW'           : 60000,

        'WEB_USER_INACTIVITY_DELAY'   : 60000,


        'ERROR_POLLING':20,


        'I18N'  : '@@I18N',

        'COMMUNICATION_ERROR_MESSAGE' : '@@communicationErrorMessage',

        'IS_DISPLAY_AS_BUTTON': '@@isDisplayAsButton',

        'CTC_BUTTON':{
          'BUTTON_DEFAULT':'@@CTCButtonDefault',
          'BUTTON_NOT_AVAILABLE':'@@CTCButtonNotAvailable',
          'BUTTON_IS_CHATTING':'@@CTCButtonIsChatting'
        },

        'WCB_BUTTON':{
          'BUTTON_DEFAULT':'@@WCBButtonDefault',
          'BUTTON_NOT_AVAILABLE':'@@WCBButtonNotAvailable',
          'BUTTON_IS_CALLING':'@@WCBButtonIsChatting'
        },

        'HELP_BUBBLE_VISIBLE':false,


        'ALLOW_SIP_NUMBER':false,

        'EMOJI_VISIBLE':true,

        'ATTACHMENT_VISIBLE':false,

        'ASK_QUESTION_BEFORE_CHAT':true,

        'CHAT_FORM':
          [
            {
              'type':'title',
              'textKey' : 'CHAT_FORM_TITLE'
            },
            {
              'type':'button',
              'textKey' : 'CHAT_FORM_VALID_BUTTON'
            }
          ]
        }
      };

    configuration.read(conf);
    $rootScope.$apply();
    expect(configuration).not.toBe(undefined);
  });

});
